#include "file.h"

/* Reads a file, given its path, a buffer to copy into, the buffer size, and mode. */
void
file_read(const char* path, void* buffer, size_t size, const char* mode)
{
	SDL_RWops* io;

	printf("Reading from %s...\n", path);

	io = SDL_RWFromFile(path, mode);

	SDL_RWread(io, buffer, size, 1);

	SDL_RWclose(io);
}

/* Writes data to a file. */
void
file_write(const char* path, void* data, size_t size, const char* mode)
{
	SDL_RWops* io;

	printf("Writing to %s...\n", path);

	io = SDL_RWFromFile(path, mode);

	SDL_RWwrite(io, data, size, 1);
}
