#pragma once

#include "camera.h"
#include "glew.h"
#include "window.h"
#include "vao.h"
#include "vbo.h"

typedef struct Renderer
{
	SDL_GLContext glContext;
	Window* window;
	Camera camera;
	VBO vbo;	// Vertex Buffer Object
	VBO ebo;	// Element Buffer Object
	VAO vao;	// Vertex Array Object
} Renderer;

void renderer_init(Renderer* self, Window* window);
void renderer_viewport_window_set(Renderer* self);
void renderer_clear_color_set(Renderer* self, vec4 color);
void renderer_clear(Renderer* self);
void renderer_update(Renderer* self);
void renderer_free(Renderer* self);
void renderer_present(Renderer* self);
