#pragma once

#include "../../COMMON.h"

#define ECS_FUNCTION_COUNT ECS_FUNCTION_DRAW + 1
typedef enum ECSFunctionType
{
	ECS_FUNCTION_ADD,
	ECS_FUNCTION_DELETE,
	ECS_FUNCTION_TICK,
	ECS_FUNCTION_DRAW
} ECSFunctionType;

#define ECS_COMPONENT_COUNT ECS_COMPONENT_SPRITE + 1
typedef enum ECSComponentType
{
	ECS_COMPONENT_SPRITE
} ECSComponentType;

typedef struct ECS;
typedef struct Game;

typedef void (*ECSRegister)(ECS);
typedef void (*ECSFunction)(ECS, void*);

typedef struct ECSsystem
{
	ECSFunction functions[ECS_FUNCTION_COUNT];
} ECSSystem;

typedef struct ECSComponentInfo
{
	ECSSystem system;
	ECSComponentType type;
	size_t size;
};

typedef struct ECSComponentList
{
	ECSSustem system;
	ECSComponentType type;
	void* components; /* dynamic array */
};

typedef struct ECS
{
	Game* game;
	ECSComponentList lists[ECS_COMPONENT_COUNT];
	u32 nextID;
} ECS;

